%def_with M24

%if_with M24
%define _release alt3.M24.1
%else
%define _release alt4
%endif

Name: dosemu
Version: 1.3.2
Release: %_release
Serial: 1
Packager: Grigory Batalov <bga@altlinux.ru>

Summary: The Linux DOS emulator
Summary(ru_RU.KOI8-R):  DOS  Linux
License: GPL
Group: Emulators
Url: http://dosemu.sourceforge.net/

# re-packing to bz2 isn't allowed by dosemu's license ;-)
Source0: http://heanet.dl.sourceforge.net/sourceforge/dosemu/%name-%version.tgz
# icons from Mandrake
Source2: dosemu-1.1.4-mdk-xdosemu.xpm.gz
Source3: dosemu-1.1.4-mdk-xdosemu-mini.xpm.gz
Source4: dosemu-1.1.4-mdk-xdosemu-large.xpm.bz2

Source5: dosemu-1.3.2-alt-dosemu-bin-x.xml
Source6: dosemu-1.3.2-alt-dosemu-bin-nox.xml
# patch 1.2.0 -> 1.2.1
#Source7: http://heanet.dl.sourceforge.net/sourceforge/dosemu/patchset-1.2.1.tar.bz2

# sources and precompiled fonts
Source9: dosemu-1.2.0.1-alt-fonts.tar.bz2

# xdosemu wrapper
Source12: dosemu-1.3.2-alt-xdosemu.wrapper
# default /etc/dosemu.users
Source13: dosemu-1.2.0.1-alt-dosemu.users

# compiletime settings
Patch3: dosemu-1.1.4.15-alt-compile.patch
# bdftopcf and mkfontdir removing
Patch4: dosemu-1.3.2-alt-makefile.patch.gz
# README.ALT
Patch5: dosemu-1.1.4.15-alt-readme.patch.bz2
# HP1100 cp866 fonts howto
Patch6: dosemu-1.1.4-alt-hp1100.patch.gz
# define locale while installing to user's directory
Patch7: dosemu-1.2.2-alt-locale2.patch.gz

# patches from SourceForge bugtracker
# loop in coopthreads removed (ID #605551)
Patch11: dosemu-1.1.4-stas-coopthreads.diff

# oplocks fix (?) (Sergey Suleymanov)
# (just stored here, not applied)
Patch16: dosemu-1.1.3.2-oplocks.patch

# Patches from Stas Sergeev <stssppnn@yahoo.com>
# http://dosemu.sourceforge.net/stas/
# (all included in 1.1.4.6)

# Fix blinking attribute that corrupts characters
# in Norton Diags and DOS Navigator
Patch20: dosemu-1.3.2-bart-blinking.patch

Obsoletes: xdosemu
Provides: xdosemu = %version-%release

# for wrapper call
Requires: xvt, %_bindir/dosemu.bin

# Added on Mon May 23 2005
BuildRequires: XFree86-devel flex libSDL-devel libslang-devel libgpm-devel glibc-devel libalternatives-devel

%description
This package allows MS-DOS programs to be started in Linux. A virtual
machine (the DOS box) provides the necessary BIOS functions and emulates
most of the chip devices (e.g. timer, interrupt- and keyboard controler)
Documentation can be found in %_defaultdocdir/%name-%version and in the man
page, as well as in the sources.
You probably need dosemu-freedos package too.

%description -l ru_RU.KOI8-R
DOSEmu    MS-DOS  Linux. 
 (DOS)    BIOS  
 ,   ,  
 .     %_defaultdocdir/%name-%version
    (man). , ,   .
,     dosemu-freedos.

%package bin-x
Summary: Dosemu binary with X11 support
License: GPL
Group: Emulators
PreReq: alternatives
Provides: %_bindir/dosemu.bin

%description bin-x
The Linux DOS Emulator binary (dosemu.bin) with XFree86/Xorg and
SDL support.

%package bin-nox
Summary: Dosemu binary without X11 support
License: GPL
Group: Emulators
PreReq: alternatives
Provides: %_bindir/dosemu.bin

%description bin-nox
The Linux DOS Emulator binary (dosemu.bin) without XFree86/Xorg or
SDL support.

%prep
%setup -q -n %name-%version
# template for future patchsets
#%__tar xjf %SOURCE7
#sh tmp/do_patch

%__mv -f compiletime-settings.devel compiletime-settings
%patch3 -p0
%patch4 -p1
# README.ALT
#%patch5 -p1
%patch6 -p1
%patch7 -p1

##%patch11 -p0

%patch20 -p0

%__subst "s!#[[:space:]]*\(\$_cli_timeout[[:space:]]*=[[:space:]]*\)(.*!\1(10)!g" etc/dosemu.conf
%__subst "s!#[[:space:]]*\(\$_ttylocks[[:space:]]*=[[:space:]]*\)\".*!\1\"/var/lock/serial\"!g" etc/dosemu.conf

# copy sources and precompiled VGA fonts
%__tar xjf %SOURCE9 -C etc
%__gzip etc/*.pcf

# to avoid automatic autoreconf call
#touch configure.ac configure

%build
%__subst "s! x on! x off!g" compiletime-settings
%__subst "s! plugin_sdl on! plugin_sdl off!g" compiletime-settings
%configure --with-pthreads
%make_build WAIT=no prefix=%_prefix
%__cp -f bin/dosemu.bin dosemu.bin.nox

%make clean

%__subst "s! x off! x on!g" compiletime-settings
%__subst "s! plugin_sdl off! plugin_sdl on!g" compiletime-settings
%configure --with-pthreads
%make_build WAIT=no prefix=%_prefix
%__cp -f bin/dosemu.bin dosemu.bin.x

%install
# install itself
%make_install install DESTDIR=%buildroot prefix=%prefix \
             mandir=%_mandir docdir=%_defaultdocdir/%name-%version
# /var/lib/dosemu for custom DOS
%__mkdir_p %buildroot%_localstatedir/dosemu

# xdosemu wrapper
%__install -m755 %SOURCE12 %buildroot%_bindir/xdosemu.wrapper
# default /etc/dosemu.users
%__install -m644 %SOURCE13 %buildroot%_sysconfdir/dosemu.users
# copy icons
%__mkdir_p %buildroot{%_iconsdir,%_liconsdir,%_miconsdir}
%__gzip  -cd %SOURCE2 > %buildroot%_iconsdir/xdosemu.xpm
%__gzip  -cd %SOURCE3 > %buildroot%_miconsdir/xdosemu.xpm
%__bzip2 -cd %SOURCE4 > %buildroot%_liconsdir/xdosemu.xpm
# adjusting docs
#%__mv %buildroot%_sysconfdir/%name/global.conf %buildroot%_defaultdocdir/%name-%version
%__install -m644 doc/HP1100-cp866-fonts-HOWTO.txt %buildroot%_defaultdocdir/%name-%version/

# install x/nox binaries
%__install -m755 dosemu.bin.x %buildroot%_bindir/dosemu.bin.x
%__install -m755 dosemu.bin.nox %buildroot%_bindir/dosemu.bin.nox

# install alternatives
%__install -d %buildroot%_altdir
%__install -m644 %SOURCE5 %buildroot%_altdir/dosemu-bin-x.xml
%__install -m644 %SOURCE6 %buildroot%_altdir/dosemu-bin-nox.xml

# Menu entry for xdosemu
%__mkdir_p %buildroot%_menudir
%__cat >%buildroot%_menudir/xdosemu <<EOF
?package(%name-bin-x):command="%_bindir/xdosemu.wrapper" needs="X11" \
icon="xdosemu.xpm" section="Applications/Emulators" title="DOS emulator" \
longtitle="DOS emulator running under X"
EOF

%post
# (making fontlist)
if [ -x %_x11bindir/mkfontdir ]; then
   (cd %_datadir/dosemu/Xfonts; %_x11bindir/mkfontdir)
fi

%preun
# (removing fontlist)
if [ $1 = "0" -a -f %_datadir/dosemu/Xfonts/fonts.dir ]; then
   %__rm -f %_datadir/dosemu/Xfonts/fonts.dir
fi

%triggerpostun bin-x -- dosemu < 1:1.3.2-alt3.M24.1
[ -f %_altdir/dosemu-bin-x.xml ] && %register_alternatives dosemu-bin-x.xml

%triggerpostun bin-nox -- dosemu < 1:1.3.2-alt3.M24.1
[ -f %_altdir/dosemu-bin-nox.xml ] && %register_alternatives dosemu-bin-nox.xml

%post bin-x
%register_alternatives dosemu-bin-x.xml
%update_menus

%preun bin-x
%unregister_alternatives dosemu-bin-x.xml

%postun bin-x
%clean_menus

%post bin-nox
%register_alternatives dosemu-bin-nox.xml

%preun bin-nox
%unregister_alternatives dosemu-bin-nox.xml

%files
%config(noreplace) %_sysconfdir/dosemu.conf
%config(noreplace) %_sysconfdir/dosemu.users
%config(noreplace) %_sysconfdir/global.conf
%exclude %_bindir/dosemu.bin*
%exclude %_bindir/xdosemu*
%_bindir/*
%dir %_localstatedir/dosemu
%dir %_datadir/dosemu
%_datadir/dosemu/*
%_iconsdir/xdosemu.xpm
%_miconsdir/xdosemu.xpm
%_liconsdir/xdosemu.xpm
%doc %_defaultdocdir/%name-%version
%doc %_man1dir/*

%files bin-x
%_altdir/dosemu-bin-x.xml
%_bindir/dosemu.bin.x
%_bindir/xdosemu*
%_menudir/xdosemu

%files bin-nox
%_altdir/dosemu-bin-nox.xml
%_bindir/dosemu.bin.nox

%changelog
* Wed Aug 10 2005 Grigory Batalov <bga@altlinux.ru> 1:1.3.2-alt3.M24.1
- Fix upgrade to bin-x/bin-nox with triggers
- Backport to Master 2.4

* Thu Aug 04 2005 Grigory Batalov <bga@altlinux.ru> 1:1.3.2-alt3
- Split to dosemu, dosemu-bin-x and dosemu-bin-nox

* Thu Jun 09 2005 Grigory Batalov <bga@altlinux.ru> 1:1.3.2-alt2
- Patch against blinking character attribute (for Norton Diags
  and DOS Navigator)

* Mon May 23 2005 Grigory Batalov <bga@altlinux.ru> 1:1.3.2-alt1
- 1.3.2
- Build requirements were updated

* Wed Apr 06 2005 Grigory Batalov <bga@altlinux.ru> 1:1.2.2-alt4
- Another try to specify target CPU

* Tue Mar 01 2005 Grigory Batalov <bga@altlinux.ru> 1:1.2.2-alt3
- External/internal charset detection was fixed
- Menu group was changed to 'Applications/Emulators'
- Correct build arch was specified

* Thu Aug 26 2004 Grigory Batalov <bga@altlinux.ru> 1:1.2.2-alt2
- Tr arguments escaped in locale detection ( by voins@ )

* Tue Jul 13 2004 Grigory Batalov <bga@altlinux.ru> 1:1.2.2-alt1
- 1.2.2 release

* Sun Jul 04 2004 Grigory Batalov <bga@altlinux.ru> 1:1.2.1-alt2
- Patched to 1.2.1.2
- Contains filename unicode translation

* Thu Mar 11 2004 Grigory Batalov <bga@altlinux.ru> 1:1.2.1-alt1
- 1.2.1

* Thu Feb 19 2004 Grigory Batalov <bga@altlinux.ru> 1:1.2.0-alt1
- 1.2.0 release
- Patched to 1.2.0.1
- Xdosemu.wrapper updated

* Tue Oct 21 2003 Grigory Batalov <bga@altlinux.ru> 1:1.1.99-alt1
- 1.2.0rc1 aka 1.1.99.1

* Mon Jun 09 2003 Grigory Batalov <bga@altlinux.ru> 1:1.1.5-alt1
- 1.1.5

* Thu Apr 10 2003 Grigory Batalov <bga@altlinux.ru> 1:1.1.4-alt4
- Dosemu updated to 1.1.4.15 (so includes most previous patches)
- $_ttylocks set to /var/lock/serial

* Sun Jan 12 2003 Grigory Batalov <bga@altlinux.ru> 1:1.1.4-alt3
- Wrong links in dosemu-bin.tgz fixed
- Dosemu updated to 1.1.4.3
- Patches from SourceForge bugtracker included:
  + loop in coopthreads (ID #605551)
  + newlines in X selection (ID #666068)
  + MFS bug (ID #666518)
- PrtScr patch by Stas Sergeev
- Comcom patches by Clarence Dang and Stas Sergeev

* Wed Jan 08 2003 Grigory Batalov <bga@altlinux.ru> 1:1.1.4-alt2
- Another parsing method choosen
- System-wide cyrillic defaults removed

* Fri Dec 27 2002 Grigory Batalov <bga@altlinux.ru> 1:1.1.4-alt1.1
- Preun section fixed

* Sun Dec 22 2002 Grigory Batalov <bga@altlinux.ru> 1:1.1.4-alt1
- DOSEmu upgraded to 1.1.4
- Dosemu-freedos-bin.tgz moved to external package

* Fri Nov 01 2002 Grigory Batalov <bga@altlinux.ru> 1:1.1.3-alt5
- DOSEmu upgraded to 1.1.3.5
- Remaining patches from Stas Sergeev updated
- CP1251 support fixed

* Sun Aug 11 2002 Grigory Batalov <bga@altlinux.ru> 1:1.1.3-alt4
- DOSEmu updated to 1.1.3.2
- Patches from Stas Sergeev updated
- Kernel upgraded to 1.1.26b (build 2026b)
- FreeCOM (command.com) upgraded to 0.83 beta 44

* Thu Apr 11 2002 Grigory Batalov <bga@altlinux.ru> 1.1.3-alt3
- Fixed execution by root
- Removed systemwide fonts

* Mon Apr 08 2002 Grigory Batalov <bga@altlinux.ru> 1.1.3-alt2
- Specfile ceanup

* Thu Apr 04 2002 Grigory Batalov <bga@altlinux.ru> 1.1.3-alt1
- 1.1.3
- Added cp1251 layout and cp866 fonts

* Sat Jan 13 2001 AEN <aen@logic.ru> 1.0.1-ipl8mdk
- RE  adaptation

* Thu Oct 19 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.0.1-7mdk
- Fix gcc2.96  and various compilation problems.

* Wed Sep 20 2000 Francis Galiegue <fg@mandrakesoft.com> 1.0.1-6mdk
- Large icon is now transparent
- Let users at least do some things

* Fri Sep 15 2000 Francis Galiegue <fg@mandrakesoft.com> 1.0.1-4mdk
- More macros
- Added large icon
- fix %post for menus

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.0.1-3mdk
- automatically added BuildRequires

* Thu Jul 20 2000 Francis Galiegue <fg@mandrakesoft.com> 1.0.1-2mdk
- BMacros
- hdimage.freedos is %config(noreplace)

* Wed Jul 05 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.1-1mdk
- new release

* Mon Apr 10 2000 Francis Galiegue <fg@mandrakesoft.com> 1.0.0-5mdk

- Use new icons from LN
- Menu entry changed accordingly
- no icon for dosemu package, only for xdosemu

* Fri Apr 07 2000 Francis Galiegue <fg@mandrakesoft.com> 1.0.0-4mdk

- freedos doesn't depend on dosemu
- freedos provides dosimage
- Both xdosemu and dosemu require dosimage
- Doubt: is mtools a Requires or a BuildRequires ?

* Mon Apr 03 2000 Francis Galiegue <fg@mandrakesoft.com> 1.0.0-3mdk

- Added %defattr for freedos

* Wed Mar 22 2000 Francis Galiegue <fg@mandrakesoft.com> 1.0.0-2mdk

- Rebuilt on kenobi

* Mon Mar 13 2000 Francis Galiegue <francis@mandrakesoft.com> 1.0.0-1mdk

- Version 1.0.0
- Changed group to match those of 7.1
- Build as non root
- Added menu entry for xdos
- spec file rework
- let spec-helper do its job
* Tue Dec 07 1999 Jerome Dumonteil <jd@mandrakesoft.com>
- added _tmppath in buildroot
- build release

* Wed Jul 14 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- 0.99.13 version.

* Mon Jul 05 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Reinserting Mandrake adaptations for maintenance release.

* Mon Jun 07 1999 Dale Lovelace <dale@redhat.com>
- remove ^H's from documentation
- freedos version beta 2
- add autoexec.bat and config.sys for path
- add freedos utils
- add vim

* Wed Mar 31 1999 Preston Brown <pbrown@redhat.com>
- add dexe stuff back into package

* Fri Mar 26 1999 Preston Brown <pbrown@redhat.com>
- remove hdimage.first link on deinstallation of freedos.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 2)

* Wed Mar 17 1999 Matt Wilson <msw@redhat.com>
- fixed %post and %postun scripts
- version 0.99.10

* Tue Jan 12 1999 Matt Wilson <msw@redhat.com>
- version 0.99.6

* Sat Oct 10 1998 Cristian Gafton <gafton@redhat.com>
- strip binaries
- version 0.98.1
- freedos has its own subpackage

* Wed Jun 24 1998 Alan Cox <alan@redhat.com>
- Wrote additional fixes for dexe overflow problem in parser.y

* Tue Jun 23 1998 Alan Cox <alan@redhat.com>
- Applied the security fixes from Hans Lerman

* Fri May 08 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri Apr 10 1998 Cristian Gafton <gafton@redhat.com>
- added DOS-C kernel and FreeDos utilities

* Thu Jan 29 1998 Cristian Gafton <gafton@redhat.com>
- updated spec file to include all the available commands
- uses a buildroot
- ship mkfatimage16, which is the only binary that can create a real hdimage
  file

* Mon Nov 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Updated to 0.66.7
- Ported to glibc

* Wed Apr 16 1997 Erik Troan <ewt@redhat.com>
- Updated to 0.66.2.
- Removed /usr/bin/load-dosmods as we don't need emumod.o anymore

* Tue Mar 11 1997 Michael K. Johnson <johnsonm@redhat.com>
- Modify the default configuration file to use /var/lock in
  ascii format for lock files, as specified in the FSSTD/FHS.

* Thu Mar 06 1997 Michael K. Johnson <johnsonm@redhat.com>
- Assume vm86plus system call does not exist.
- N.B. This should be changed in a future version with a later kernel
  that supports that system call by default.
- Install the mkhdimage program.
